/*
 * Copyright(C) OASIS(R) 2005,2009. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.
 */
package com.vendor.scaimpl;

import java.lang.reflect.Field;

import org.oasisopen.sca.client.SCAClientFactory;

/**
 * Sample vendor bootstrap that registers the vendor implementation using a System Property.
 */
public class VendorBootstrap
{

    /**
     * Sets the SCAClientFactory implementation to use using injection directly into the SCAClientFactory.
     * This needs to be done before any use of the SCAClientFactory.
     */
    public static void bootstrap() throws Exception {
        // Set the Vendor Implementation class using injection directly into the SCAClientFactory
        final Field defaultFactoryField = SCAClientFactory.class.getDeclaredField("defaultFactory");
        defaultFactoryField.setAccessible(true);
        defaultFactoryField.set(null, new VendorSCAClientFactoryImpl());
        defaultFactoryField.setAccessible(false);
    }
}
